﻿
@{
    ViewData["Title"] = "پرسش و پاسخ";
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
}

@section scripts{
    <script src="~/ADMIN/JS/moment.js"></script>
    <script src="~/ADMIN/JS/moment-jalaali.js"></script>

    <script src="~/ADMIN/JS/persian-date.js"></script>
    <script src="~/ADMIN/JS/persian-datepicker-0.4.5.js"></script>

    <script>
        function showDialog_CategoryID() {
            $('#categoryselectdialog_CategoryID').data("kendoDialog").open();
        }

        var Tags_bound = false;
        function onDataBound(e, s) {
            if (!Tags_bound) {
                var multiselect = $("\#Tags").data("kendoMultiSelect");
                var m = '1,2';
                multiselect.unbind('dataBound');
                multiselect.dataSource.filter({});
                multiselect.value(m.split(","));
                console.log(s)
            }
            Tags_bound = true;
        }
        function addNew(value) {
            var ret = $.ajax({
                type: "POST",
                url: "/admin/Tags/Tags_Create",
                data: { value },
                dataType: "json",
                success: function (response) {
                    var multiselect = $("\#Tags").data("kendoMultiSelect");
                    multiselect.dataSource.read();
                }
            });
        }
    </script>

    <script id="noDataTemplate" type="text/x-kendo-tmpl">
        # var value = instance.input.val(); #
        # var id = instance.element[0].id; #
        <div>
            موردی یافت نشد ، آیا مایل به افزودن این مورد هستید ؟ - '#: value #'
        </div>
        <br />
        <button style="background:\#999;color:\#fff" class="k-button" onclick="addNew('#: value #')" ontouchend="addNew('#: value #')">افزودن این مورد</button>
    </script>

}

@section Styles{
    <link href="~/ADMIN/Content/Styles/persian-datepicker-0.4.5.css" rel="stylesheet" />
    <style>
        .mybadge {
            background-color: #3f51b5;
            padding: 2px 10px;
            border-radius: 10px;
            color: #FFF;
        }

        .k-command-cell a {
            margin-bottom: 10px;
        }

        .k-widget.k-treeview {
            direction: ltr;
        }

        .k-edit-form-container {
            width: 100% !important;
        }

        .editor-label {
            width: 20% !important;
        }

        .editor-field {
            width: 70% !important;
        }

        a.k-button.k-button-icontext {
            padding-top: 1px !important;
            border: none;
            padding: 5px 10px !important;
            border-radius: 5px !important;
            margin-bottom: 5px !important;
            width: 90%;
            display: inline-flex;
        }

            a.k-button.k-button-icontext.k-grid-edit {
                background: #9dbbff !important;
                color: #213a74;
            }

        .questiontitle {
            background: #f6f6f6;
            padding: 5px;
            width: 100%;
            display: inline-block;
            margin-bottom: 5px;
        }

        .breadcrumpbar {
            background: #e2ebff;
            padding: 2px 5px;
            width: 100%;
            display: inline-block;
            margin-bottom: 5px;
            font-weight: 500;
        }

        .tagsbar {
            background: #ffffff;
            padding: 2px 5px;
            width: 100%;
            display: inline-block;
            margin-bottom: 5px;
            font-weight: 500;
            border: 1px solid #efefef;
        }

        a.k-button.k-button-icontext.k-grid-delete {
            color: #aa3d3d !important;
            background: #f5f5f5 !important;
        }
    </style>
}
@Html.Partial("CategoryTreeview", "CategoryID")

<div class="wrapper-grid">
    <div class="k-rtl">
        @(Html.Kendo().Grid<LawMingo.Models.DomainModel.Comment>()
            .Name("Questions")
            .Columns(columns =>
            {
                columns.Bound(c => c.Code);
                columns.Bound(c => c.AuthorEmail);
                columns.Bound(c => c.Time).Format("{0:yyyy-MM-dd HH:mm:ss}").HtmlAttributes(new { style = "white-space: pre-line;text-align:center;letter-spacing: 2px;font-size: 12px;" }).Title("تاریخ ثبت");
                columns.Bound(c => c.Subject).Title("محتوا")
                .ClientTemplate(
                                    "#if(BreadCrump.length > 0){#<span class='breadcrumpbar'>#= BreadCrump.join(' > ') #</span>#}#" +
                                    "#if(Tags != null){#<span class='tagsbar'>#= Tags #</span>#}#" +
                                    "<span class='questiontitle'>#=Subject#</span><br/>" +
                                    "<span>#=Content#</span><br/>"
                                );
                columns.Command(command =>
                {
                    command.Destroy().Text("حذف");
                    command.Edit().Text("ویرایش");
                    command.Custom("activeComment").Click("activeComment").Text("انتشار");
                    command.Custom("readComment").Click("readComment").Text("خوانده شد");
                });
            })
            //.ToolBar(toolbar =>
            //{
            //    toolbar.Create().Text("پرسش جدید");
            //})
            .Events(ev => ev.DataBound("CommentsBound").Edit("CommentEdit"))
          .ColumnMenu()
            .Editable(editable => editable.Mode(GridEditMode.PopUp).Window(q => q.Width(800)))
            .Pageable(pageable =>
                pageable
                .Refresh(true)
                .Input(true)
                .PageSizes(true)
                .ButtonCount(10).Messages(m => m.ItemsPerPage("نمایش در هر صفحه"))
            )
          .Navigatable()
          .Sortable(sortable =>
          {
              sortable.SortMode(GridSortMode.SingleColumn);
          })
          .Filterable()
            .Scrollable(s => s.Height("auto").Enabled(false))
          .DataSource(dataSource => dataSource
              .Ajax()
                .Sort(s => s.Add(a => a.Time).Descending())
              .Model(model => model.Id(p => p.CommentID))
              .Read(read => read.Action("Questions_Read", "Questions"))
              .Create(create => create.Action("Questions_Create", "Questions"))
              .Update(update => update.Action("Questions_Update", "Questions"))
              .Destroy(destroy => destroy.Action("Questions_Destroy", "Questions"))
          )
          .ClientDetailTemplateId("CommentAnswers-Template")
        )
    </div>
</div>

<script id="active-template" type="text/x-kendo-template">
    <span>عدم انتشار</span>
</script>

<script>

    function activeComment(e) {
        e.preventDefault();
        var dataItem = this.dataItem($(e.currentTarget).closest("tr"));
        var ret = $.ajax({
            type: "POST",
            url: "/admin/Questions/active",
            data: { id: dataItem.CommentID },
            dataType: "json",
            complete: function (response) {
                var msg = response ? "منتشر شد" : "عدم انتشار";
                var grid = $(e.delegateTarget).data("kendoGrid");
                grid.refresh();
                alert(msg);
            }
        });
    }

    function readComment(e) {
        e.preventDefault();
        var dataItem = this.dataItem($(e.currentTarget).closest("tr"));
        var ret = $.ajax({
            type: "POST",
            url: "/admin/Questions/read",
            data: { id: dataItem.CommentID },
            dataType: "json",
            complete: function (response) {
                //var msg = response ? "خوانده شد" : "عدم انتشار";
                //var grid = $(e.delegateTarget).data("kendoGrid");
                //grid.refresh();
                alert('خوانده شد');
            }
        });
    }

    function test(val) {
        //alert(val);
        return ({
            PostID: val
        });
    }

    function PostsBound(e) {
        var data = e.sender.dataSource.data();
        $.each(data, function (i, row) {
            if (row.Disable) {
                $('tr[data-uid="' + row.uid + '"] ').css("background-color", "#ffebeb");
            }
        })
    }

    function CommentsBound(e) {
        var data = e.sender.dataSource.data();
        console.log("CommentsBound");
        $.each(data, function (i, row) {
            console.log(row.IsActive)
            if (!row.IsActive) {
                $('tr[data-uid="' + row.uid + '"] ').css("background-color", "#ffebeb");
            }
            if (!row.IsRead) {

                $('tr[data-uid="' + row.uid + '"] ').css("font-weight", "bold");
            }
        })
        var grid = this;
        grid.tbody.find("tr[role='row']").each(function (index, value) {
            var model = grid.dataItem(this);
            grid.tbody.find("tr[role='row']").each(function (index, value) {
                var model = grid.dataItem(this);
                $(this).find('td').each(function (index, value) {
                    if ($(this).text().includes(":") && $(this).text().includes("-")) {
                        var result = moment($(this).text(), 'YYYY-M-D HH:mm:ss')
                            .format('jYYYY/jM/jDD HH:mm:ss')
                        result = result.replace(' ', '\n');
                        $(this).text(result)
                    }
                })
            });
        });
    }

    function AnswersBound(e) {
        var data = e.sender.dataSource.data();
        var grid = this;
        grid.tbody.find("tr[role='row']").each(function (index, value) {
            var model = grid.dataItem(this);
            grid.tbody.find("tr[role='row']").each(function (index, value) {
                var model = grid.dataItem(this);
                $(this).find('td').each(function (index, value) {
                    if ($(this).text().includes(":") && $(this).text().includes("-")) {
                        var result = moment($(this).text(), 'YYYY-M-D HH:mm:ss')
                            .format('jYYYY/jM/jDD HH:mm:ss')
                        result = result.replace(' ', '\n');
                        $(this).text(result)
                    }
                })
            });
        });
    }

    function RelatedEdit(e, PostID) {
        e.model.set("PostID", PostID);
        $(e.container["0"].firstChild.children[2]).hide();
        $(e.container["0"].firstChild.children[3]).hide();
    }

    function RelatedEdit2(val) {
        alert(val);
    }

    function Edit(e) {

        $(e.container["0"].firstChild.children[0]).hide();
        $(e.container["0"].firstChild.children[1]).hide();
        $(e.container["0"].firstChild.children[2]).hide();
        $(e.container["0"].firstChild.children[3]).hide();

        var kendoWindow = e.container.data("kendoWindow");
        if (e.model.isNew()) {
            kendoWindow.setOptions({
                title: "پست جدید"
            });
        }
        else {
            kendoWindow.setOptions({
                title: "ویرایش پست"
            });
        }

        $(".PublishTime").pDatepicker({
            format: "YYYY/MM/DD HH:mm:ss",
            timePicker: {
                enabled: true
            },
            onSelect: function () {
                var ww = moment($("." + e.container.prevObject["0"].lastElementChild.attributes["0"].ownerDocument.activeElement.className).val(), 'jYYYY/jM/jD HH:mm:ss')
                    .format('YYYY-M-D HH:mm:ss') // 2013-8-25 16:40:00
                $("#" + e.container.prevObject["0"].lastElementChild.attributes["0"].ownerDocument.activeElement.className).val(ww).trigger('change');
                //moment.loadPersian()
            }
        });
    }
    function AnswersEdit(e) {
        $(e.container["0"].firstChild.children[0]).hide();
        $(e.container["0"].firstChild.children[1]).hide();

        $(e.container["0"].firstChild.children[2]).hide();
        $(e.container["0"].firstChild.children[3]).hide();

        $(e.container["0"].firstChild.children[6]).hide();
        $(e.container["0"].firstChild.children[7]).hide();

        $(e.container["0"].firstChild.children[8]).hide();
        $(e.container["0"].firstChild.children[9]).hide();

        $(e.container["0"].firstChild.children[10]).hide();
        $(e.container["0"].firstChild.children[11]).hide();


        $(e.container["0"].firstChild.children[14]).hide();
        $(e.container["0"].firstChild.children[15]).hide();

        $(e.container["0"].firstChild.children[16]).hide();
        $(e.container["0"].firstChild.children[17]).hide();


        $(e.container["0"].firstChild.children[18]).hide();
        $(e.container["0"].firstChild.children[19]).hide();


        $(e.container["0"].firstChild.children[20]).hide();
        $(e.container["0"].firstChild.children[21]).hide();

        $(e.container["0"].firstChild.children[22]).hide();
        $(e.container["0"].firstChild.children[23]).hide();


    }
    function CommentEdit(e) {

        $(e.container["0"].firstChild.children[0]).hide();
        $(e.container["0"].firstChild.children[1]).hide();

        $(e.container["0"].firstChild.children[2]).hide();
        $(e.container["0"].firstChild.children[3]).hide();

        $(e.container["0"].firstChild.children[6]).hide();
        $(e.container["0"].firstChild.children[7]).hide();

        $(e.container["0"].firstChild.children[8]).hide();
        $(e.container["0"].firstChild.children[9]).hide();

        $(e.container["0"].firstChild.children[14]).hide();
        $(e.container["0"].firstChild.children[15]).hide();

        $(e.container["0"].firstChild.children[20]).hide();
        $(e.container["0"].firstChild.children[21]).hide();

        $(e.container["0"].firstChild.children[22]).hide();
        $(e.container["0"].firstChild.children[23]).hide();

        $(e.container["0"].firstChild.children[24]).hide();
        $(e.container["0"].firstChild.children[25]).hide();

    }
</script>

<script id="CommentAnswers-Template" type="text/kendo-tmpl">
    @(Html.Kendo().Grid<LawMingo.Models.DomainModel.Comment>()
       .Name("Answers_#=CommentID#")
       .Columns(columns =>
       {
           //columns.Bound(c => c.Counselor.Name);
           columns.ForeignKey(p => p.CounselorID, (System.Collections.IEnumerable)ViewData["Counselors"], "CounselorID", "Name")
                    .Title("مشاور")
                    .Width(100);

           //columns.Bound(c => c.Time).Format("{0:yyyy-MM-dd HH:mm:ss}").HtmlAttributes(new { style = "white-space: pre-line;text-align:center;letter-spacing: 2px;font-size: 12px;" }).Title("تاریخ ثبت");
           columns.Bound(c => c.Content).Title("محتوا");
                columns.Bound(c => c.Time).Format("{0:yyyy-MM-dd HH:mm:ss}")
                .HtmlAttributes(new { style = "white-space: pre-line;text-align:center;letter-spacing: 2px;font-size: 12px;" }).Title("تاریخ");
           columns.Command(command =>
           {
               command.Destroy().Text("حذف");
               command.Edit().Text("ویرایش");
           });
       })
       .ToolBar(toolbar =>
       {
           toolbar.Create().Text("پاسخ جدید");
       }
       )
       .Events(ev => ev.DataBound("AnswersBound").Edit("AnswersEdit"))
       .ColumnMenu()
       .Editable(editable => editable.Mode(GridEditMode.PopUp).Window(q => q.Width(800)))
       //.Pageable(pageable =>
       //    pageable
       //    .Refresh(true)
       //    .Input(true)
       //    .PageSizes(true)
       //    .ButtonCount(10).Messages(m => m.ItemsPerPage("نمایش در هر صفحه"))
       //)
       //.Navigatable()
       //.Selectable(selectable =>
       //{
       //    selectable.Mode(GridSelectionMode.Single);
       //    selectable.Type(GridSelectionType.Row);
       //})
       //.Sortable(sortable =>
       //{
       //    sortable.SortMode(GridSortMode.SingleColumn);
       //})
       .Filterable()
       .Scrollable(s => s.Height("auto").Enabled(false))
       .DataSource(dataSource => dataSource
           .Ajax()
           .Sort(s => s.Add(a => a.Time).Descending())
           .Model(model => model.Id(p => p.CommentID))
           .Read(read => read.Action("Questions_Read", "Questions", new { _CommentID = "#=CommentID#" }))
           .Create(create => create.Action("Questions_Create", "Questions", new { _CommentID = "#=CommentID#" }))
           .Update(update => update.Action("Questions_Update", "Questions"))
           .Destroy(destroy => destroy.Action("Questions_Destroy", "Questions"))
       )
       .ToClientTemplate()
    )
</script>